// NiVEcppSamlpe.h

#pragma once

#pragma unmanaged
//#include <nmmintrin.h>   // MMX-SSE4.2߃ZbggpꍇCN[h //
//#include <smmintrin.h>   // MMX-SSE4.1߃ZbggpꍇCN[h //
#include <intrin.h>      // MMX-SSE3߃ZbggpꍇCN[h   //
#include <emmintrin.h>   // MMX-SSE2߃ZbggpꍇCN[h   //
#include <xmmintrin.h>   // MMX-SSE߃ZbggpꍇCN[h    //
#include <mmintrin.h>    // MMX߃ZbggpꍇCN[h        //
#include <Windows.h> 
#include <math.h> 
#include <process.h>
#pragma managed

using namespace System;
using namespace System::Collections::Generic;
using namespace nicoAE::Plugin;
using namespace nicoAE::Plugin::Controls; 
using namespace nicoAE::Plugin::Interface;
using namespace nicoAE::Plugin::Property;
using namespace nicoAE::Plugin::Threading;
using namespace nicoAE::Plugin::Utils;
using namespace System::Windows::Forms;
using namespace System::Drawing;
using namespace System::Drawing::Imaging;
using namespace System::Diagnostics;
using namespace System::Runtime::InteropServices;
using namespace System::Drawing::Drawing2D;
//using namespace nicoAE::History;
#pragma warning(disable: 4101)//u[Jϐ 1 xgĂ܂Bv}


namespace nivepp {
#pragma unmanaged
	unsigned long SSEVer() {
		unsigned long d;
		unsigned long c;
		long a = 0;
		_asm {
                xor     eax, eax
                cpuid
                mov a,eax
		}
		if (a >= 1) {
			    a = 1;
				_asm {
						mov     eax, 1
						cpuid
						mov d,edx
						mov c,ecx
				}
			    if ((d >> 23) & 1 ) a =  1;// MMX
			    if ((d >> 25) & 1 ) a = 10;//SSE1
			    if ((d >> 26) & 1 ) a = 20;//SSE2
			    if ((c >>  0) & 1 )  a = 30;//SSE3
			    if ((c >> 19) & 1 )  a = 41;//SSE4.1
			    if ((c >> 20) & 1 )  a = 42;//SSE4.2
		}
		return a;
	}
	struct bgra {
		float B,G,R,A;
	};

	struct ThreadArg {
		byte *ps;
		unsigned long n;
	};
		
	unsigned __stdcall MONO_SSE_T( void* pArguments )
	{
		ThreadArg *pArg = (ThreadArg *)pArguments;

		unsigned long s = (unsigned long)pArg->ps;
		unsigned long n = pArg->n;
		__asm	pxor	xmm0, xmm0				 
		__asm	mov		eax, 0x000000ff			
		__asm	movd	xmm1, eax				 
		__asm	pshufd	xmm1, xmm1, 0			 // }XN
		__asm	mov		eax, 0x3de978d5				// BW 0.114f
		__asm	movd	xmm4, eax				 
		__asm	PSHUFD	xmm4, xmm4, 0			 
		__asm	mov		eax, 0x3f1645a2				// GW 0.299f
		__asm	movd	xmm5, eax				 
		__asm	PSHUFD	xmm5, xmm5, 0			 
		__asm	mov		eax, 0x3e991687				// RW 0.299f
		__asm	movd	xmm6, eax				 
		__asm	PSHUFD	xmm6, xmm6, 0
		__asm	mov		esi, s					
		__asm	mov		ecx, n
		{
scan:;
			__asm	MOVDQA	xmm2, [esi]	 // \[X
			__asm	add		esi,0x10
			__asm	MOVDQA	xmm0, xmm2					// B
			__asm	MOVDQA	xmm3, xmm2					// G
			__asm	MOVDQA	xmm7, xmm2					// R
			__asm	PAND	xmm0, xmm1				 // B}XN
			__asm   PSRLD	xmm3, 8					 // 
			__asm   PSRLD	xmm7, 16				


			__asm	CVTDQ2PS xmm0,xmm0				 // DWORD => float
			__asm	PAND	xmm3, xmm1				 // G}XN
			__asm	MULPS	xmm0, xmm4				 // B

			__asm	CVTDQ2PS xmm3,xmm3				 // DWORD => float
			__asm	PAND	xmm7, xmm1				 // R}XN
			__asm	MULPS	xmm3, xmm5				 // G

			__asm	CVTDQ2PS xmm7,xmm7				 // DWORD => float
			__asm   PSRLD	xmm2, 24				 // A
			__asm	MULPS	xmm7, xmm6				 // R

			__asm	ADDPS	xmm0, xmm3				 
			__asm	ADDPS	xmm0, xmm7				 

			__asm	CVTPS2DQ xmm0,xmm0				 // float => DWORD 
			__asm   PSLLD	xmm2, 8					
			__asm	POR		xmm2, xmm0				
			__asm   PSLLD	xmm2, 8					
			__asm	POR		xmm2, xmm0				
			__asm   PSLLD	xmm2, 8					
			__asm	POR		xmm2, xmm0				
			__asm	MOVDQA	[esi-0x10],xmm2			 // 
			__asm	loop scan
		}
		_endthreadex( 0 );
		return 0;
	} 
	void MONO_SSE_MT(byte *BGRA, int sx, int sy, int st, int t) {

		unsigned long n =  (st/0x10 * sy);
		unsigned long s = (unsigned long)BGRA;
		if (t > 64) t = 64; 

		ThreadArg Arg[64];
		HANDLE	hT[64];
		for (int i = 0; i < t; i++) {
			Arg[i].ps = BGRA+(n/t)*i*0x10;
			Arg[i].n = (i == t-1) ? n-(n/t)*i : (n/t);
			hT[i] = (HANDLE)_beginthreadex( NULL, 0, &MONO_SSE_T, (void *)&Arg[i], 0, NULL );
		}
	    WaitForMultipleObjects(t, hT, TRUE, INFINITE);
	}
	void MONO_unmanaged_fixed_point(byte *BGRA, int n) {
		unsigned long *ARGB = (unsigned long *)(BGRA);
		for (int i = 0; i < n; i++) {
			unsigned long px = *ARGB;
			unsigned long R = (px >> 16) & 0x000000ff;
			unsigned long G = (px >> 8 ) & 0x000000ff;
			unsigned long B = (px      ) & 0x000000ff;
			unsigned long M = (R*(unsigned long)(0x10000*0.299f)+G*(unsigned long)(0x10000*0.587f)+B*(unsigned long)(0x10000*0.114f)+0x8000)>>16;
			*ARGB = (px & 0xff000000) | (M << 16) | (M << 8) | M;

			ARGB++;
		}

		//Parallel::For(0, sy, gcnew System::Action<int>(MONO_managed_thread));
	}
	void MONO_unmanaged(byte *BGRA, int n) {
		unsigned long *ARGB = (unsigned long *)(BGRA);
		for (int i = 0; i < n; i++) {
			unsigned long px = *ARGB;
			unsigned long R = (px >> 16) & 0x000000ff;
			unsigned long G = (px >> 8 ) & 0x000000ff;
			unsigned long B = (px      ) & 0x000000ff;
			unsigned long M = (unsigned long)(R*0.299f+G*0.587f+B*0.114f+0.5f);
			*ARGB = (px & 0xff000000) | (M << 16) | (M << 8) | M;

			ARGB++;
		}

		//Parallel::For(0, sy, gcnew System::Action<int>(MONO_managed_thread));
	}

#pragma managed

	void DrawTextE(Graphics^ g, int x, int y, String^ text) {
		SolidBrush^ bw = gcnew SolidBrush(Color::FromArgb(0xff, 0xff, 0xff, 0xff));
		SolidBrush^ bb = gcnew SolidBrush(Color::FromArgb(0xff, 0, 0, 0));
		float fx = (float)x;
		float fy = (float)y;
		try
		{
			Font^ font = gcnew Font("lr SVbN", 8);
			g->DrawString(text, font, bw, (fx - 1), (fy - 1));
			g->DrawString(text, font, bw, (fx + 0), (fy - 1));
			g->DrawString(text, font, bw, (fx + 1), (fy - 1));
			g->DrawString(text, font, bw, (fx - 1), (fy + 0));
			g->DrawString(text, font, bw, (fx + 1), (fy + 0));
			g->DrawString(text, font, bw, (fx - 1), (fy + 1));
			g->DrawString(text, font, bw, (fx + 0), (fy + 1));
			g->DrawString(text, font, bw, (fx + 1), (fy + 1));
			g->DrawString(text, font, bb, (fx + 0), (fy + 0));
			delete font;
		}
		catch (ArgumentException^ exception1)
		{
		}
		delete bw;
		delete bb;
	}
    public ref class Nivepp : public IEffect, public IDisposable
    {
		private: 
			Dictionary<String^,  IEffectProperty^>^ p;
			float *px;
		public:
			byte *BGRA;
			int sx;
			int sy;
			int st;
			void MONO_managed(byte *BGRA, int n) {
				unsigned long *ARGB = (unsigned long *)(BGRA);
				for (int i = 0; i < n; i++) {
					unsigned long px = *ARGB;
					unsigned long R = (px >> 16) & 0x000000ff;
					unsigned long G = (px >> 8 ) & 0x000000ff;
					unsigned long B = (px      ) & 0x000000ff;
					unsigned long M = (unsigned long)Math::Round(R*0.299f+G*0.587f+B*0.114f);
					*ARGB = (px & 0xff000000) | (M << 16) | (M << 8) | M;

					ARGB++;
				}
			}
			~Nivepp(void) {
			}
			virtual property String^ PluginName {
				String^ get() {return "C++vOC";};
			}
			virtual property String^ Category {
				String^ get() {return "C++JeS";};
			}
			virtual property bool PresetProperty {
				bool get() {return false;};
			}
			virtual property MediaType CorrespondingType
			{
				MediaType get() { return (MediaType)(MediaType::Image | MediaType::Video); }
			}
			IHost^ ho;
			virtual void Initialize(IHost^ host, MediaInfo info)
			{
				ho = host;
			}
			virtual array<IPropertyEditControl^> ^GetControls(void)
			{
				return gcnew array<IPropertyEditControl^> {
					gcnew SelectableEditControl("Z@"),

				};  
			}
			virtual array<IEffectProperty^> ^GetDefaultProperty(void)
			{
				array< String^>^ items = gcnew array< String^> {"C++/CLI ( C#)","Unmanaged x87","Unmanaged Fixed Point","Unmanaged SSE2","Unmanaged SSE2 MT",};
				return gcnew array<IEffectProperty^> {
					gcnew SelectableProperty("Z@", items,  0),
				};  
			}
			virtual array<KeyFrame^> ^GetPresetProperty(int index, String^ propertyName)
			{
				throw gcnew NotImplementedException("//GetPresetProperty");
			}
			virtual Bitmap^ ProcessingImage(Bitmap^ image, array<IEffectProperty^>^ pro)
			{
				p = gcnew Dictionary<String^, IEffectProperty^>();
				for (int i = 0; i < pro->Length; i++)
				{
					p[pro[i]->PropertyName] = pro[i];
				}
				SelectableProperty^ sel = safe_cast<SelectableProperty^>(p["Z@"]);
				int a = SSEVer();
				SYSTEM_INFO sysInfo;
				GetSystemInfo(&sysInfo);
				Stopwatch^ sw = gcnew Stopwatch;
				sw->Start();
			    BitmapData^ bitmapdata = image->LockBits(Drawing::Rectangle(0, 0, image->Width, image->Height), ImageLockMode::ReadWrite, image->PixelFormat);
				BGRA = (byte *)bitmapdata->Scan0.ToPointer(); 
				__int64 t1 = sw->ElapsedMilliseconds;
				sx = image->Width;
				sy = image->Height;
				st = bitmapdata->Stride;
				switch (sel->TypeSafeValue) {
					case 0:// C++/CLI
						MONO_managed(BGRA, sy*st/4);
						break;
					case 1:// Unmanaged x87
						MONO_unmanaged(BGRA, sy*st/4);
						break;
					case 2:// Unmanaged fixed point 
						MONO_unmanaged_fixed_point(BGRA, sy*st/4);
						break;
					case 3:// Unmanaged SSE2
						if (a >= 20) MONO_SSE_MT(BGRA, sx, sy, st, 1);
						break;
					case 4:// Unmanaged SSE2 MT
						if (a >= 20) MONO_SSE_MT(BGRA, sx, sy, st, ho->MultiThread ? sysInfo.dwNumberOfProcessors : 1);
						break;
				}
				__int64 t2 = sw->ElapsedMilliseconds;
		        image->UnlockBits(bitmapdata);
				__int64 t3 = sw->ElapsedMilliseconds;
				sw->Stop();

				Graphics^ g = Graphics::FromImage(image);
				DrawTextE(g, 100, 20, " "+sx+"x"+sy);
				DrawTextE(g, 100, 30, "}`Xbh"+(ho->MultiThread ? "ON" : "OFF"));
				DrawTextE(g, 100, 40, "RA="+sysInfo.dwNumberOfProcessors);
				if (a == 1) DrawTextE(g, 100, 50, "MMX");
				if (a >= 10) DrawTextE(g, 100, 50, "SSE"+a/10.0);
				DrawTextE(g, 100, 60, "Operation type:"+sel->Items[sel->TypeSafeValue]);
				DrawTextE(g, 100, 70,"LockBits+UnlockBits:"+(t1+(t3-t2)).ToString()->PadLeft(8)+"ms");
				DrawTextE(g, 100, 80,"Operation          :"+(t2-t1).ToString()->PadLeft(8)+"ms");
				DrawTextE(g, 100, 90,"Total time         :"+t3.ToString()->PadLeft(8)+"ms");
				DrawTextE(g, 100,110,"}`XbhŌvZĂ̂Unmanaged SSE2 MT̂݁B");
				delete g;

				return image;
			}
			virtual array<unsigned char>^  ProcessingAudio(array<unsigned char>^ audio,  array<IEffectProperty^>^ pro)
			{
				throw gcnew NotImplementedException("//ProcessingAudio");
			}
	public:
 
	};


}

